import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provinceGetColdHousesDashboard = createAsyncThunk(
  "GET_PROVINCE_COLD_HOUSES_DASHBOARD",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    const { data, status } = await axios.get("cold-house-total-dashboard");
    dispatch(LOADING_END());
    return { data, status };
  }
);

export const provinceGetAllStewardsService = createAsyncThunk(
  "PROVINCE_GET_ALL_STEWARDS_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.get("stewards-for-cold-house/", {});
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceCreateColdHouseService = createAsyncThunk(
  "PROVINCE_CREATE_COLD_HOUSE_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.post("cold-house/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceEditColdHouseService = createAsyncThunk(
  "PROVINCE_EDIT_COLD_HOUSE_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.put("cold-house/0/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
